export interface AniListItem {
    data: {
        Media: {
            id: number,
            idMal: number,
            title: {
                romaji: string,
                english: string,
            },
            description: string,
            coverImage: {
                medium: string,
                large: string,
                extraLarge: string,
                color: string,
            },
            tags: [{
                id: number,
                name: string,
                description: string,
                category: string,
                rank: number,
                isGeneralSpoiler: boolean,
                isMediaSpoiler: boolean,
                isAdult: boolean
            }]
        }
    }
}

export interface AniSearchList {
    data: {
        Page: {
            pageInfo: {
                total: number,
                currentPage: number,
                lastPage: number,
                hasNextPage: boolean,
                perPage: number
            },
            media: [{
                id: number,
                idMal: number,
                title: {
                    romaji: string,
                    english: string,
                    native: string,
                },
                coverImage: {
                    extraLarge: string,
                    color: string,
                },
            }],
        },
    }
}

export interface AniListUser {
    "data": {
        "Viewer": {
            id: number,
            name: string,
        }
    }
}

export interface AniListCurrentUserWatchList {
    data: Data;
}

export interface Data {
    Page: Page;
}

export interface Page {
    pageInfo:  PageInfo;
    mediaList: MediaList[];
}

export interface MediaList {
    id:       number;
    mediaId:  number;
    userId:   number;
    media:    Media;
    status:   StatusEnum;
    notes:    string | null;
    progress: number;
    score:    number;
    repeat:   number;
    user:     User;
}

export interface Media {
    id:          number;
    idMal:       number;
    title:       Title;
    description: string;
    coverImage:  CoverImage;
    season:      string;
    seasonYear:  number;
    episodes:    number;
}

export interface CoverImage {
    large: string;
}

export interface Title {
    romaji:  string | null;
    english: string | null;
    native:  string;
}

export enum StatusEnum {
    Completed = "COMPLETED",
    Current = "CURRENT",
    Dropped = "DROPPED",
    Planning = "PLANNING",
    Repeating = "REPEATING",
}

export interface User {
    id:         number;
    statistics: Statistics;
}

export interface Statistics {
    anime: Anime;
}

export interface Anime {
    count:    number;
    statuses: StatusElement[];
}

export interface StatusElement {
    status: StatusEnum;
    count:  number;
}

export interface PageInfo {
    total:       number;
    perPage:     number;
    currentPage: number;
    lastPage:    number;
    hasNextPage: boolean;
}
